extern "C" {
    #define __KEYBIOS_H__
    #include "fxlib.h"
    #include "MonochromeLib.h"
    #include "stdlib.h"
    #include "string.h"
}
#include <iostream>


//
// entete de compatibilite SH4

#define KEY_CHAR_0 OS2(0x30,71)
#define KEY_CHAR_1 OS2(0x31,72)
#define KEY_CHAR_2 OS2(0x32,62)
#define KEY_CHAR_3 OS2(0x33,52)
#define KEY_CHAR_4 OS2(0x34,73)
#define KEY_CHAR_5 OS2(0x35,63)
#define KEY_CHAR_6 OS2(0x36,53)
#define KEY_CHAR_7 OS2(0x37,74)
#define KEY_CHAR_8 OS2(0x38,64)
#define KEY_CHAR_9 OS2(0x39,54)
#define KEY_CHAR_DP OS2(0x2e,61)
#define KEY_CHAR_EXP OS2(0x0f,51)
#define KEY_CHAR_PMINUS OS2(0x87,41)
#define KEY_CHAR_PLUS OS2(0x89,42)
#define KEY_CHAR_MINUS OS2(0x99,32)
#define KEY_CHAR_MULT OS2(0xa9,43)
#define KEY_CHAR_DIV OS2(0xb9,33)
#define KEY_CHAR_FRAC OS2(0xbb,75)
#define KEY_CHAR_LPAR OS2(0x28,55)
#define KEY_CHAR_RPAR OS2(0x29,45)
#define KEY_CHAR_COMMA OS2(0x2c,35)
#define KEY_CHAR_STORE OS2(0x0e,25)
#define KEY_CHAR_LOG OS2(0x95,66)
#define KEY_CHAR_LN OS2(0x85,56)
#define KEY_CHAR_SIN OS2(0x81,46)
#define KEY_CHAR_COS OS2(0x82,36)
#define KEY_CHAR_TAN OS2(0x83,26)
#define KEY_CHAR_SQUARE OS2(0x8b,67)
#define KEY_CHAR_POW OS2(0xa8,57)
#define KEY_CTRL_EXE OS2(30004,31)
#define KEY_CTRL_DEL OS2(30025,44)
#define KEY_CTRL_AC OS2(30015,32)
#define KEY_CTRL_FD OS2(30046,65)
#define KEY_CTRL_EXIT OS2(30002,47)
#define KEY_CTRL_SHIFT OS2(30006,78)
#define KEY_CTRL_ALPHA OS2(30007,77)
#define KEY_CTRL_OPTN OS2(30008,68)
#define KEY_CTRL_VARS OS2(30016,58)
#define KEY_CTRL_UP OS2(30018,28)
#define KEY_CTRL_DOWN OS2(30023,37)
#define KEY_CTRL_LEFT OS2(30020,38)
#define KEY_CTRL_RIGHT OS2(30021,27)
#define KEY_CTRL_F1 OS2(30009,79)
#define KEY_CTRL_F2 OS2(30010,69)
#define KEY_CTRL_F3 OS2(30011,59)
#define KEY_CTRL_F4 OS2(30012,49)
#define KEY_CTRL_F5 OS2(30013,39)
#define KEY_CTRL_F6 OS2(30014,29)
#define KEY_CTRL_MENU OS2(30003,48)
 
#ifndef isOS2// This is new
 
typedef int(*sc_i2cp2sip)(char*, char*, short int*, short int*);
const unsigned int sc0015[] = { 0xD201D002, 0x422B0009, 0x80010070, 0x0015 };
#define GlibGetOSVersionInfo (*(sc_i2cp2sip)sc0015)
 
int OSVersionAsInt(void)
{
char mainversion;
char minorversion;
short release;
short build;
GlibGetOSVersionInfo( &mainversion, &minorversion, &release, &build );
return ( ( mainversion << 24 ) & 0xFF000000 ) | ( ( minorversion << 16 ) & 0x00FF0000 ) | ( release & 0x0000FFFF );
}
 
#define isOS2 (OSVersionAsInt() >= 0x02020000)
#define OS2(x,y) ((OSVersionAsInt() >= 0x02020000)?y:x)
 
#endif
 
const unsigned short* keyboardregister = (unsigned short*)0xA44B0000;
 
unsigned short key[8] = {0};
 
int KeyDown(int keycode)
{
if(isOS2)
{
int row, col, word, bit;
row = keycode%10;
col = keycode/10-1;
word = row>>1;
bit = col + 8*(row&1);
memcpy(key, keyboardregister, sizeof(unsigned short) << 3);
 
Sleep(1); //slow down, this function is faster than IsKeyDown() :-P
 
return (0 != (key[word] & 1<<bit));
}
else
{
return IsKeyDown(keycode);
}
}
 
#define IsKeyDown(x) KeyDown(x)
#define IsKeyUp(x) !KeyDown(x)

// fin de l entete de compatibilite SH4
//


//
// fonctions utiles

unsigned char* int2str(unsigned char* c, int n)
{
    if(n==0)
    {
        c[0] = '0';
        c[1] = 0;
    }
    else
    {
        int i, l=0;
        if(n<0)
        {
            c[0] = '-';
            n=abs(n);
            l++;
        }
        for(i=n ; i ; i/=10)
            l++;
        c[l] = 0;
        for(i=n ; i ; i/=10)
            c[--l] = i%10+'0';
    }
    return c;
}

int chiffres(int n) {
    int nbch;
    nbch = (n>= 100000000) ? 9 : (n>= 10000000) ? 8 : (n>= 1000000) ? 7 : (n>= 100000) ? 6 : (n>= 10000) ? 5 : (n>= 1000) ? 4 : (n>= 100) ? 3 : (n>= 10) ? 2 : 1;
    return nbch;
}

void echanger(int tab[], int a, int b)
{
    int t = tab[a];
    tab[a] = tab[b];
    tab[b] = t;
}

void tri_pivot(int tab[], int deb, int fin)
{
    if(deb >= fin)
        return;

    int gauche = deb-1;
    int droite = fin+1;
    const int pivot = tab[deb];

    while(true)
    {
        do droite--;
        while(tab[droite] < pivot);

        do gauche++;
        while(tab[gauche] > pivot);

        if(gauche < droite)
            echanger(tab, gauche, droite);
        else break;
    }
    tri_pivot(tab, deb, droite);
    tri_pivot(tab, droite+1, fin);
}

// fonctions utiles
//



//
// variables globales

int temps;
int plaques[6];
int plaques_originales[6];
unsigned char operateurs[5];
int poses[5][2];
int resultats[5];
int objectif;
int ligne;
bool ok;
bool abandon;

int meilleur;
int meilleur_tour;
unsigned char meilleurs_operateurs[5];
int meilleurs_poses[5][2];
int meilleurs_resultats[5];
bool chiffres_utilises[6];
bool resultats_utilises[5];

// fin des variables globales
//


void augtemps() {
    temps++;
}

void dessin() {
    const unsigned char F[6][18] = {
        {0x7f, 0xf7, 0x80, 0xf, 0xbc, 0x4f, 0xa0, 0xcf, 0xb9, 0x4f, 0xa0, 0x4f, 0xa0, 0xef, 0x80, 0xf, 0x7f, 0xf7 },
        {0x7f, 0xf7, 0x80, 0xf, 0xbd, 0xcf, 0xa0, 0x2f, 0xb8, 0xcf, 0xa1, 0xf, 0xa1, 0xef, 0x80, 0xf, 0x7f, 0xf7 },
        {0x7f, 0xf7, 0x80, 0xf, 0xbd, 0xcf, 0xa0, 0x2f, 0xb8, 0xcf, 0xa0, 0x2f, 0xa3, 0xcf, 0x80, 0xf, 0x7f, 0xf7 },
        {0x7f, 0xf7, 0x80, 0xf, 0xbc, 0x8f, 0xa1, 0xf, 0xba, 0x4f, 0xa3, 0xef, 0xa0, 0x4f, 0x80, 0xf, 0x7f, 0xf7 },
        {0x7f, 0xf7, 0x80, 0xf, 0xbd, 0xef, 0xa1, 0xf, 0xb8, 0xcf, 0xa0, 0x2f, 0xa3, 0xcf, 0x80, 0xf, 0x7f, 0xf7 },
        {0x7f, 0xf7, 0x80, 0xf, 0xbc, 0xef, 0xa1, 0xf, 0xbb, 0xcf, 0xa1, 0x2f, 0xa0, 0xcf, 0x80, 0xf, 0x7f, 0xf7 } };
    // int decalage_droit = 0;
    // for(int i=0; i<6; i++) {
    //     int c = chiffres(plaques[i]);
    //     if(c > decalage_droit)
    //         decalage_droit = c;
    // }

    ML_clear_vram();

    unsigned char obj[4];
    int2str(obj, objectif);
    if(!abandon) {
        PrintXY(1, 1, "But:", 0);
        PrintXY(26, 1, obj, 0);
    }
    else PrintXY(1, 1, "Solution:", 0);

    for(int i=0; i<6; i++) {
        if(plaques[i] != 0) {
            unsigned char plaque[8];
            int2str(plaque, plaques[i]);

            int decalage_droit = chiffres(plaques[i]);

            if(!abandon) ML_bmp_or(F[i], 111 - 6*decalage_droit, 11*i, 13, 9);
            PrintXY(126 - 6*decalage_droit, 11*i + 1, plaque, 0);
        }
    }

    for(int i=0; i<6; i++) {
        if(!poses[i][0]) break;

        unsigned char pos[8];
        int2str(pos, poses[i][0]);
        int len = chiffres(poses[i][0]);

        PrintXY(3, 10*i + 16, pos, 0);

        if(operateurs[i] == ' ') break;
        unsigned char op[2]= {operateurs[i], 0};

        PrintXY(3 + 6*len, 10*i + 16, op, 0);

        if(!poses[i][1]) break;

        int2str(pos, poses[i][1]);
        PrintXY(9 + 6*len, 10*i + 16, pos, 0);
        len += chiffres(poses[i][1]);

        int2str(pos, resultats[i]);
        PrintXY(9 + 6*len, 10*i + 16, "=", 0);
        PrintXY(15 + 6*len, 10*i + 16, pos, 0);
    }

    ML_display_vram();
}

void erreurs(int erreur) {
    const unsigned char err[]={
        0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
        0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf, 
        0xbd, 0xce, 0x7a, 0x5c, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xbd, 0x2f, 0x6f, 
        0xa1, 0x29, 0x42, 0x52, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x21, 0x28, 0x2f, 
        0xb9, 0xce, 0x72, 0x5c, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x38, 0xce, 0x2f, 
        0xa1, 0x29, 0x42, 0x52, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x21, 0x28, 0x2f, 
        0xbd, 0x29, 0x79, 0x92, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xbd, 0x2f, 0x6f, 
        0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf, 
        0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff };


    ML_rectangle(9, 6, 117, 54, 1, ML_BLACK, ML_WHITE);
    ML_bmp_or(err, 9, 6, 109, 9);
    switch(erreur) {
        case 0:
            PrintXY(15, 22, "Le resultat doit",0);
            PrintXY(25, 36, "etre non nul.", 0);
            break;
        case 1:
            PrintXY(15, 22, "Le resultat doit",0);
            PrintXY(28, 36, "etre entier.", 0);
            break;
        case 3:
            PrintXY(20, 22, "Entrez d'abord",0);
            PrintXY(24, 36, "un operateur.", 0);
            break;
    }
    ML_display_vram();
    while(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_SHIFT));
}

void felicitations() {
    ML_rectangle(9, 6, 117, 54, 1, ML_BLACK, ML_WHITE);
    PrintXY(18, 22, "Felicitations !",0);
    PrintXY(30, 36, "Temps:", 0);

    unsigned char tps[5];
    int2str(tps, temps);
    PrintXY(72, 36, tps, 0);

    ML_display_vram();
    while(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_SHIFT) && IsKeyUp(KEY_CTRL_EXIT));
    while(IsKeyDown(KEY_CTRL_EXE) || IsKeyDown(KEY_CTRL_SHIFT) || IsKeyDown(KEY_CTRL_EXIT));
}

void pose(int indice) {
    if(plaques[indice] == 0) return;
    else if(!poses[ligne][0]) {
        poses[ligne][0]=plaques[indice];
        plaques[indice]=0;
        tri_pivot(plaques, 0, 5);
    }
    else if(operateurs[ligne] == ' ') erreurs(3);
    else {
        int p0=poses[ligne][0];
        int p1 = plaques[indice];
        if(p0<p1) {
            int pt=p0;
            p0=p1;
            p1=pt;
        }
        switch(operateurs[ligne]) {
            case '+':
                resultats[ligne] = p0 + p1;
                if(resultats[ligne] == meilleur) ok = true;
                poses[ligne][0] = p0;
                poses[ligne][1] = p1;
                plaques[indice]=resultats[ligne];
                tri_pivot(plaques, 0, 5);
                ligne++;
                break;
            case '*':
                resultats[ligne] = p0*p1;
                if(resultats[ligne] == meilleur) ok = true;
                poses[ligne][0] = p0;
                poses[ligne][1] = p1;
                plaques[indice]=resultats[ligne];
                tri_pivot(plaques, 0, 5);
                ligne++;
                break;
            case '-':
                if(p0 == p1) erreurs(0);
                else {
                    resultats[ligne] = p0 - p1;
                    if(resultats[ligne] == meilleur) ok = true;
                    poses[ligne][0] = p0;
                    poses[ligne][1] = p1;
                    plaques[indice]=resultats[ligne];
                    tri_pivot(plaques, 0, 5);
                    ligne++;
                }
                break;
            case '/':
                if(p0 % p1 != 0) erreurs(1);
                else {
                    resultats[ligne] = p0 / p1;
                    if(resultats[ligne] == meilleur) ok = true;
                    poses[ligne][0] = p0;
                    poses[ligne][1] = p1;
                    plaques[indice]=resultats[ligne];
                    tri_pivot(plaques, 0, 5);
                    ligne++;
                }
                break;
        }
    }
    if(ligne == 5) plaques[0] = 0;
}

void pose_chiffre(int n) {
    for(int i=0; i<6; i++) {
        if(plaques[i] == n) {
            pose(i);
            return;
        }
    }
}

void pose_op(unsigned char op) {
    if(!poses[ligne][0]) pose(0);
    operateurs[ligne] = op;
}

void vide_plaque(int n) {
    for(int i=0; i<6; i++) {
        if(plaques[i] == n) {
            plaques[i] = 0;
            return;
        }
    }
}

void insere_plaque(int n) {
    for(int i=0; i<6; i++) {
        if(plaques[i] == 0) {
            plaques[i] = n;
            return;
        }
    }  
}

void arriere() {
    if(ligne == 0 && poses[0][0] == 0) return;
    else if(ligne == 5 || (ligne != 5 && poses[ligne][0] == 0)) {
        ligne--;
        vide_plaque(resultats[ligne]);
        resultats[ligne] = 0;
        insere_plaque(poses[ligne][1]);
        poses[ligne][1] = 0;
    }
    else if(operateurs[ligne] != ' ')
        operateurs[ligne] = ' ';
    else {
        insere_plaque(poses[ligne][0]);
        poses[ligne][0] = 0;
    }

    tri_pivot(plaques, 0, 5);
}

void reinitialisation() {
    for(int i=0; i<6; i++) {
        plaques[i] = plaques_originales[i];
        chiffres_utilises[i]=false;
    }
    for(int i=0; i<5; i++) {
        operateurs[i] = ' ';
        resultats[i] = 0;
        resultats_utilises[i] = false;
        for(int j=0; j<2; j++)
            poses[i][j] = 0;
    }

    tri_pivot(plaques, 0, 5);

    ligne = 0;
}

void enregistrer_meilleure_grille()
{
    for (int i = 0; i < 5; i++)
    {
        meilleurs_resultats[i] = resultats[i];
        meilleurs_operateurs[i] = operateurs[i];
        meilleurs_poses[i][0] = poses[i][0];
        meilleurs_poses[i][1] = poses[i][1];
    }
}

bool calcul_ligne(int j)
{
    int result = 0;
    int a = poses[j][0], b = poses[j][1];
    switch (operateurs[j])
    {
        case '*':
            result = a * b;
            break;
        case '+':
            result = a + b;
            break;
        case '-':
            result = a - b;
            break;
        case '/':
            if (b == 0) return false;
            if (a % b == 0) result = a / b;
            else return false;
            break;
    }
    resultats[j] = result;
    return true;
}

void parcours_grilles(int tour)
{
    unsigned char ops[] = { '+', '-', '*', '/' };

    int interv = (temps > 1) ? 10 : 3;

    if (tour % 3 == 2)
    {
        if (poses[tour / 3][1] > poses[tour / 3][0]) return;

        for (int i = 0; i < 4; i++)
        {
            operateurs[tour / 3] = ops[i];

            if (calcul_ligne(tour / 3))
            {
                if (abs(resultats[tour / 3] - objectif) < interv)
                {
                    meilleur = resultats[tour / 3];
                    meilleur_tour = tour;
                    enregistrer_meilleure_grille();
                    operateurs[tour / 3] = ' ';
                    resultats[tour / 3] = 0;
                    return;
                }
                else if (tour < 14) parcours_grilles(tour + 1);
            }

        }
        operateurs[tour / 3] = ' ';
        return;
    }
    else
    {
        int plage = 6 + tour / 3;
        for (int i = 0; i < plage; i++)
        {
            if (i < 6)
            {
                if (!chiffres_utilises[i])
                {
                    poses[tour / 3][tour % 3] = plaques_originales[i];
                    chiffres_utilises[i] = true;
                    parcours_grilles(tour + 1);
                    if (abs(meilleur - objectif) < interv) return;
                    chiffres_utilises[i] = false;
                }
            }
            else
            {
                if (!resultats_utilises[i - 6])
                {
                    poses[tour / 3][tour % 3] = resultats[i - 6];
                    resultats_utilises[i - 6] = true;
                    parcours_grilles(tour + 1);
                    if (abs(meilleur - objectif) < interv) return;
                    resultats_utilises[i - 6] = false;
                }
            }
        }
        poses[tour / 3][(tour % 3 == 0) ? 0 : 1] = 0;
        resultats[tour / 3] = 0;
        return;
    }
}

int calcule_solution() {
    meilleur = 0;
    meilleur_tour = 15;

    ML_clear_vram();
    locate(1,1); Print("Chargement...");
    ML_display_vram();

    reinitialisation();

    for (int i = 0; i < 5; i++)
    {
        meilleurs_resultats[i] = 0;
        meilleurs_operateurs[i] = ' ';
        meilleurs_poses[i][0] = meilleurs_poses[i][1] = 0;
    }

    temps = 0;
    SetTimer(1,1000,augtemps);
    parcours_grilles(0);
    KillTimer(1);

    return meilleur;
}

void recup_meilleure_grille()
{
    for (int i = 0; i < 5; i++)
    {
        resultats[i] = meilleurs_resultats[i];
        operateurs[i] = meilleurs_operateurs[i];
        poses[i][0] = meilleurs_poses[i][0];
        poses[i][1] = meilleurs_poses[i][1];
    }
}

void generation() {
    int jeu[23] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 25, 50, 75, 100};
    for(int i=0; i<6; i++) {
        do {
            int ind = rand() % 23;
            plaques_originales[i] = jeu[ind];
            jeu[ind] = 0;
        } while(plaques_originales[i] == 0);
    }

    objectif = rand() % 894 + 106;

    abandon = false;
    ok = false;

    meilleur = calcule_solution();
    objectif = meilleur;

    reinitialisation();
}

bool jouer() {
    generation();

    temps = 0;
    SetTimer(1,1000,augtemps);
    do {
        dessin();
        while( IsKeyDown(KEY_CTRL_F1) || IsKeyDown(KEY_CTRL_F2) || IsKeyDown(KEY_CTRL_F3) || IsKeyDown(KEY_CTRL_F4) || IsKeyDown(KEY_CTRL_F5) || IsKeyDown(KEY_CTRL_F6)
             || IsKeyDown(KEY_CTRL_DEL) || IsKeyDown(KEY_CTRL_AC)
             || IsKeyDown(KEY_CHAR_1) || IsKeyDown(KEY_CHAR_2) || IsKeyDown(KEY_CHAR_3) || IsKeyDown(KEY_CHAR_4) || IsKeyDown(KEY_CHAR_5) || IsKeyDown(KEY_CHAR_6) || IsKeyDown(KEY_CHAR_7) || IsKeyDown(KEY_CHAR_8) || IsKeyDown(KEY_CHAR_9) );
        while(  IsKeyUp(KEY_CTRL_EXIT) && IsKeyUp(KEY_CTRL_MENU)
             && IsKeyUp(KEY_CHAR_PLUS) && IsKeyUp(KEY_CHAR_MINUS) && IsKeyUp(KEY_CHAR_MULT) && IsKeyUp(KEY_CHAR_DIV)
             && IsKeyUp(KEY_CTRL_F1) && IsKeyUp(KEY_CTRL_F2) && IsKeyUp(KEY_CTRL_F3) && IsKeyUp(KEY_CTRL_F4) && IsKeyUp(KEY_CTRL_F5) && IsKeyUp(KEY_CTRL_F6)
             && IsKeyUp(KEY_CTRL_DEL) && IsKeyUp(KEY_CTRL_AC) && IsKeyUp(KEY_CTRL_ALPHA)
             && IsKeyUp(KEY_CHAR_1) && IsKeyUp(KEY_CHAR_2) && IsKeyUp(KEY_CHAR_3) && IsKeyUp(KEY_CHAR_4) && IsKeyUp(KEY_CHAR_5) && IsKeyUp(KEY_CHAR_6) && IsKeyUp(KEY_CHAR_7) && IsKeyUp(KEY_CHAR_8) && IsKeyUp(KEY_CHAR_9)
             && !ok);
        if(IsKeyDown(KEY_CTRL_EXIT) || IsKeyDown(KEY_CTRL_MENU)) return false;
        else if(IsKeyDown(KEY_CTRL_F1)) pose(0);
        else if(IsKeyDown(KEY_CTRL_F2)) pose(1);
        else if(IsKeyDown(KEY_CTRL_F3)) pose(2);
        else if(IsKeyDown(KEY_CTRL_F4)) pose(3);
        else if(IsKeyDown(KEY_CTRL_F5)) pose(4);
        else if(IsKeyDown(KEY_CTRL_F6)) pose(5);
        else if(IsKeyDown(KEY_CHAR_PLUS)) pose_op('+');
        else if(IsKeyDown(KEY_CHAR_MINUS)) pose_op('-');
        else if(IsKeyDown(KEY_CHAR_MULT)) pose_op('*');
        else if(IsKeyDown(KEY_CHAR_DIV)) pose_op('/');
        else if(IsKeyDown(KEY_CHAR_1)) pose_chiffre(1);
        else if(IsKeyDown(KEY_CHAR_2)) pose_chiffre(2);
        else if(IsKeyDown(KEY_CHAR_3)) pose_chiffre(3);
        else if(IsKeyDown(KEY_CHAR_4)) pose_chiffre(4);
        else if(IsKeyDown(KEY_CHAR_5)) pose_chiffre(5);
        else if(IsKeyDown(KEY_CHAR_6)) pose_chiffre(6);
        else if(IsKeyDown(KEY_CHAR_7)) pose_chiffre(7);
        else if(IsKeyDown(KEY_CHAR_8)) pose_chiffre(8);
        else if(IsKeyDown(KEY_CHAR_9)) pose_chiffre(9);
        else if(IsKeyDown(KEY_CTRL_AC)) reinitialisation();
        else if(IsKeyDown(KEY_CTRL_DEL)) arriere();
        else if(IsKeyDown(KEY_CTRL_ALPHA)) abandon = true;
    } while(IsKeyUp(KEY_CTRL_EXIT) && IsKeyUp(KEY_CTRL_MENU) && !ok && !abandon);
    KillTimer(1);
    if(ok) {
        dessin();
        felicitations();
        return true;
    }
    else if(abandon) {
        reinitialisation();
        recup_meilleure_grille();
        dessin();
        while(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_SHIFT) && IsKeyUp(KEY_CTRL_EXIT));
        while(IsKeyDown(KEY_CTRL_EXE) || IsKeyDown(KEY_CTRL_SHIFT) || IsKeyDown(KEY_CTRL_EXIT));
        return true;
    }
    else return false;
}

int ecran_accueil() {
    const unsigned char acc1[]={
        0xf8, 0x0, 0x0, 0x1e, 0x0, 0x0, 0x0, 
        0x88, 0x0, 0x0, 0x12, 0x0, 0x0, 0x0, 
        0xd8, 0x0, 0x0, 0x1a, 0x0, 0x0, 0x0, 
        0x50, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 
        0x50, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 
        0x50, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 
        0x50, 0x3, 0xe0, 0xa, 0x1f, 0x0, 0x77, 
        0x50, 0xe, 0x2e, 0xea, 0x71, 0x77, 0x5d, 
        0xd0, 0xeb, 0xaa, 0xaa, 0x5d, 0x55, 0x63, 
        0x90, 0xaa, 0xaa, 0xaa, 0x55, 0x55, 0x2a, 
        0xbf, 0xab, 0xab, 0xab, 0x5d, 0x5d, 0x63, 
        0x80, 0x28, 0x28, 0x29, 0x41, 0x41, 0x5d, 
        0xff, 0xef, 0xef, 0xaf, 0x7f, 0x7d, 0x77, 
        0x0, 0x0, 0x0, 0xe0, 0x0, 0x7, 0x0, 
        0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 
        0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 
        0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 
        0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 
        0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 
        0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 
        0x3, 0x9c, 0xf3, 0x3c, 0x10, 0x3c, 0x0, 
        0x2, 0x52, 0x84, 0xa1, 0x17, 0xa0, 0x0, 
        0x2, 0x52, 0x84, 0x21, 0x91, 0x20, 0x0, 
        0x3, 0x9c, 0xc3, 0x31, 0x51, 0x30, 0x0, 
        0x2, 0x12, 0x80, 0xa1, 0x31, 0x20, 0x0, 
        0x2, 0x12, 0xf0, 0xbd, 0x11, 0x3c, 0x0, 
        0x2, 0x2, 0x7, 0x1, 0x1, 0x0, 0x0 };

    const unsigned char acc2[]={
        0xf0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xe0, 0x0, 0x0, 0x0, 0x38, 0xe, 0x0, 0x0, 0x1f, 
        0x90, 0x0, 0x0, 0x0, 0x0, 0x0, 0xa0, 0x0, 0x0, 0x0, 0x28, 0xa, 0x0, 0x0, 0x1f, 
        0xd0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xa0, 0x0, 0x0, 0x0, 0x28, 0xa, 0x0, 0x0, 0x1f, 
        0x50, 0x0, 0x0, 0x0, 0x0, 0x0, 0xa0, 0x0, 0x0, 0x0, 0x28, 0xa, 0x0, 0x0, 0x1f, 
        0x50, 0x0, 0x0, 0x0, 0x0, 0x0, 0xa0, 0x0, 0x0, 0x0, 0x28, 0xa, 0x0, 0x0, 0x1f, 
        0x50, 0x0, 0x0, 0x0, 0x0, 0x0, 0xbc, 0x0, 0x0, 0x0, 0x2f, 0xa, 0x0, 0x0, 0x1f, 
        0x53, 0xf0, 0x7e, 0x3e, 0xe0, 0xfe, 0x85, 0xf8, 0x3f, 0x1f, 0xa1, 0xb, 0xe3, 0xee, 0x1f, 
        0x52, 0x10, 0x42, 0xe2, 0xbe, 0x82, 0xbd, 0x8, 0x21, 0x10, 0xaf, 0x8, 0x2e, 0x2b, 0xff, 
        0x52, 0xd0, 0x5e, 0xba, 0x82, 0xba, 0xa1, 0x68, 0x2d, 0x17, 0xa8, 0xb, 0xab, 0xa8, 0x3f, 
        0x52, 0x10, 0x50, 0xaa, 0xaa, 0xaa, 0xa1, 0x8, 0x21, 0x11, 0x28, 0xa, 0xaa, 0xab, 0xbf, 
        0x5a, 0xf8, 0x5e, 0xba, 0xaa, 0xba, 0xa1, 0x7c, 0x2f, 0xbd, 0x28, 0xb, 0xab, 0xaa, 0xbf, 
        0x4a, 0x8, 0x42, 0x82, 0xaa, 0x82, 0xa1, 0x4, 0x20, 0xa1, 0x28, 0x8, 0x28, 0x2a, 0xbf, 
        0x7b, 0xf8, 0x7e, 0xfe, 0xfe, 0xbe, 0xe1, 0xfc, 0x3f, 0xbf, 0x38, 0xf, 0xef, 0xee, 0xff, 
        0x0, 0x0, 0x0, 0x0, 0x0, 0xa0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 
        0x0, 0x0, 0x0, 0x0, 0x0, 0xa0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 
        0x0, 0x0, 0x0, 0x0, 0x0, 0xa0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 
        0x0, 0x0, 0x0, 0x0, 0x0, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f };

    int seed = 0;
    while(IsKeyDown(KEY_CTRL_EXE));

    do {
        seed++;
        int seed2=seed/10;
        ML_clear_vram();
        ML_bmp_or_cl(acc1, 128-((seed2<92) ? seed2 : 92), 6, 56, 27);
        ML_bmp_or_cl(acc2, ((seed2<121) ? seed2 : 121)-114, 40, 115, 17);
        ML_display_vram();
    } while(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_SHIFT));
    while(IsKeyDown(KEY_CTRL_EXE) || IsKeyDown(KEY_CTRL_SHIFT)) seed++;

    ML_clear_vram();
    locate(6,1); Print("Commandes:");
    locate(1,2); Print("F1-F6 : poser plaque");
    locate(1,3); Print("1-9: poser chiffre");
    locate(1,4); Print("+-*/: poser operateur");
    locate(1,5); Print("ALPHA: solution");
    locate(1,6); Print("DEL: annuler action");
    locate(1,7); Print("AC: tout effacer");
    locate(1,8); Print("EXIT/MENU: quitter");
    ML_display_vram();
    while(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_SHIFT)) seed++;
    while(IsKeyDown(KEY_CTRL_EXE) || IsKeyDown(KEY_CTRL_SHIFT)) seed++;

    seed += 442;
    return seed;
}

int main() {
    int seed = ecran_accueil();
    srand(seed);
    while(jouer());
    return 1;
}

extern "C" {
    int AddIn_main(int isAppli, unsigned short OptionNum)
    {
        return main();
    }

    #pragma section _BR_Size
    unsigned long BR_Size;
    #pragma section


    #pragma section _TOP

    int InitializeSystem(int isAppli, unsigned short OptionNum){
        return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
    }

    #pragma section
}
